#include <windows.h>
#include "filter.h"
#include <emmintrin.h>
#include <math.h>

#define TRACK_N 1
TCHAR   *track_name[] =     {""};  //  gbNo[̖O
int     track_default[] =   {100};              //  gbNo[̏l
int     track_s[] =         {0};              //  gbNo[̉l
int     track_e[] =         {100};        //  gbNo[̏l

#define CHECK_N 1
TCHAR*  check_name[] = {"Px̂"};
int     check_default[] = {0};
FILTER_DLL filter = {
    FILTER_FLAG_EX_INFORMATION, //    tB^̃tO
    0,0,                        //    ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
    "gی",           //    tB^̖O
    TRACK_N,                    //    gbNo[̐ (0Ȃ疼OlNULLł悢)
    track_name,                 //    gbNo[̖OSւ̃|C^
    track_default,              //    gbNo[̏lSւ̃|C^
    track_s,track_e,            //    gbNo[̐l̉ (NULLȂS0`256)
    CHECK_N,                    //    `FbN{bNX̐ (0Ȃ疼OlNULLł悢)
    check_name,                 //    `FbN{bNX̖OSւ̃|C^
    check_default,              //    `FbN{bNX̏lSւ̃|C^
    func_proc,                  //    tB^֐ւ̃|C^ (NULLȂĂ΂܂)
    NULL,                       //    JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    func_exit,                  //    IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    func_update,                //    ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    func_WndProc,               //    ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    NULL,NULL,                  //    VXeŎg܂̂ŎgpȂł
    NULL,                       //  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
    NULL,                       //  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
    "gی Ver.120202",
    //  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
    NULL,                       //    Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    NULL,                       //    Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};

static const __m128 predict = { -0.5f, -0.5f, -0.5f, -0.5f};
static const __m128 update =  { 0.25f, 0.25f, 0.25f, 0.25f};
static const __m128 i_predict = { 0.5f, 0.5f, 0.5f, 0.5f};
static const __m128 i_update = {-0.25f, -0.25f, -0.25f, -0.25f};

typedef struct {
    BYTE* src;
    BYTE* dest;
    LONG atomic_counter;
    int srcwidth;
    int srcheight;
    int destwidth;
    int destheight;
    int src_bpl;
    int dest_bpl;
} WAVELET_PARAM, *LPWAVELET_PARAM;

int maxthread;
WAVELET_PARAM before, after;
BYTE* work;
int worksize;
float str;
BOOL done;
BOOL lumaonly;

//---------------------------------------------------------------------
//        tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
    return &filter;
}

void fwt53(int thread_id,int thread_num,void *param1, void* param2)
{
    WAVELET_PARAM* prm = (WAVELET_PARAM*)param1;
    int width = (prm->srcwidth+1) & ~1;
    int height = prm->srcheight;
    BYTE* src = prm->src;
    BYTE* dest = prm->dest;
    BYTE* ywork = work + worksize * thread_id;
    BYTE* xwork = ywork + 64 * (4 + 2 + 2);
    LONG* atomic_counter = (LONG*)(&prm->atomic_counter);
    int src_bpl = prm->src_bpl;
    int dest_bpl = prm->dest_bpl;
    
    int maxblock = (height + 3) / 4;
    int offsety = (prm->destheight / 2) * dest_bpl;
    int offsetx = (prm->destwidth / 2) * 12;
    while (TRUE)
    {
        int block = InterlockedIncrement(atomic_counter) - 1;
        if (block >= maxblock) break;
        int y0, y1, y2;
        y1 = block * 4;
        y0 = y1 - 2;
        y2 = y1 + 5;
        int yloop1, yloop2, yloop3;
        yloop2 = y2 - y0;
        if (y0 < 0)
        {
            yloop1 = 2;
            yloop2 -= 2;
        }
        else
        {
            yloop1 = 0;
        }
        if (y2 > height)
        {
            yloop3 = y2 - height;
            yloop2 -= yloop3;
        }
        else
        {
            yloop3 = 0;
        }

        int xloopcount = (width * 3 + 15) / 16;
        BYTE* src2 = src + (y0 + yloop1) * src_bpl;
        BYTE* dest2 = dest + y1 * dest_bpl / 2;
        BYTE* ywork2 = ywork + yloop1 * 64;
        BYTE* xwork2;
        __asm
        {
            mov             ecx, xloopcount
            mov             edi, xwork
            mov             eax, src_bpl
            mov             esi, src2
        align 16
        xloop_1:
            mov             xloopcount, ecx
            mov             xwork2, edi
            mov             edi, ywork2
            mov             ecx, yloop2
            
        align 16
        loop_1:
            movdqa          xmm1, [esi]
            movdqa          xmm3, [esi+16]
            punpcklwd       xmm0, xmm1
            punpckhwd       xmm1, xmm1
            punpcklwd       xmm2, xmm3
            punpckhwd       xmm3, xmm3
            psrad           xmm0, 16
            psrad           xmm1, 16
            psrad           xmm2, 16
            psrad           xmm3, 16
            cvtdq2ps        xmm0, xmm0
            cvtdq2ps        xmm1, xmm1
            cvtdq2ps        xmm2, xmm2
            cvtdq2ps        xmm3, xmm3
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
            movaps          [edi+48], xmm3
            add             esi, eax
            add             edi, 64
            sub             ecx, 1
            jnz             loop_1
            
            mov             ecx, yloop3
            test            ecx, ecx
            jz              loop_2_end
            sub             esi, eax
            sub             esi, eax
        align 16
        loop_2:
            movdqa          xmm1, [esi]
            movdqa          xmm3, [esi+16]
            punpcklwd       xmm0, xmm1
            punpckhwd       xmm1, xmm1
            punpcklwd       xmm2, xmm3
            punpckhwd       xmm3, xmm3
            psrad           xmm0, 16
            psrad           xmm1, 16
            psrad           xmm2, 16
            psrad           xmm3, 16
            cvtdq2ps        xmm0, xmm0
            cvtdq2ps        xmm1, xmm1
            cvtdq2ps        xmm2, xmm2
            cvtdq2ps        xmm3, xmm3
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
            movaps          [edi+48], xmm3
            sub             esi, eax
            add             edi, 64
            sub             ecx, 1
            jnz             loop_2
        loop_2_end:
            
            mov             ecx, yloop1
            test            ecx, ecx
            jz              padding_end
            mov             edi, ywork2
            movaps          xmm0, [edi+64]
            movaps          xmm1, [edi+80]
            movaps          xmm2, [edi+96]
            movaps          xmm3, [edi+112]
            movaps          [edi-64 ], xmm0
            movaps          [edi-48 ], xmm1
            movaps          [edi-32 ], xmm2
            movaps          [edi-16 ], xmm3
            movaps          xmm0, [edi+128]
            movaps          xmm1, [edi+144]
            movaps          xmm2, [edi+160]
            movaps          xmm3, [edi+176]
            movaps          [edi-128 ], xmm0
            movaps          [edi-112 ], xmm1
            movaps          [edi-96  ], xmm2
            movaps          [edi-80  ], xmm3
        padding_end:
            
            movaps          xmm7, predict
            movaps          xmm6, update
            mov             esi, ywork
            mov             edi, xwork2
            mov             ecx, 2
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            movaps          xmm2, [esi+32]
            movaps          xmm3, [esi+48]
            addps           xmm0, [esi+128]
            addps           xmm1, [esi+144]
            addps           xmm2, [esi+160]
            addps           xmm3, [esi+176]
            mulps           xmm0, xmm7
            mulps           xmm1, xmm7
            mulps           xmm2, xmm7
            mulps           xmm3, xmm7
            addps           xmm0, [esi+64]
            addps           xmm1, [esi+80]
            addps           xmm2, [esi+96]
            addps           xmm3, [esi+112]
            movaps          [esi+64], xmm0
            movaps          [esi+80], xmm1
            movaps          [esi+96], xmm2
            movaps          [esi+112], xmm3
            add             esi, 128
        align 16
        loop_3:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            movaps          xmm2, [esi+32]
            movaps          xmm3, [esi+48]
            addps           xmm0, [esi+128]
            addps           xmm1, [esi+144]
            addps           xmm2, [esi+160]
            addps           xmm3, [esi+176]
            mulps           xmm0, xmm7
            mulps           xmm1, xmm7
            mulps           xmm2, xmm7
            mulps           xmm3, xmm7
            addps           xmm0, [esi+64]
            addps           xmm1, [esi+80]
            addps           xmm2, [esi+96]
            addps           xmm3, [esi+112]
            movaps          [esi+64], xmm0
            movaps          [esi+80], xmm1
            movaps          [esi+96], xmm2
            movaps          [esi+112], xmm3
            addps           xmm0, [esi-64]
            addps           xmm1, [esi-48]
            addps           xmm2, [esi-32]
            addps           xmm3, [esi-16]
            mulps           xmm0, xmm6
            mulps           xmm1, xmm6
            mulps           xmm2, xmm6
            mulps           xmm3, xmm6
            addps           xmm0, [esi]
            addps           xmm1, [esi+16]
            addps           xmm2, [esi+32]
            addps           xmm3, [esi+48]
            movaps          [esi], xmm0
            movaps          [esi+16], xmm1
            movaps          [esi+32], xmm2
            movaps          [esi+48], xmm3
            add             esi, 128
            sub             ecx, 1
            jnz             loop_3
            
            sub             esi, 64*4
            mov             ecx, 4
        align 16
        loop_4:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+64]
            movaps          xmm2, [esi+128]
            movaps          xmm3, [esi+192]
            movaps          xmm4, xmm0
            movaps          xmm5, xmm1
            unpcklps        xmm4, xmm2
            unpckhps        xmm0, xmm2
            unpcklps        xmm5, xmm3
            unpckhps        xmm1, xmm3
            movaps          xmm2, xmm4
            movaps          xmm3, xmm0
            unpcklps        xmm2, xmm5
            unpckhps        xmm4, xmm5
            unpcklps        xmm3, xmm1
            unpckhps        xmm0, xmm1
            movaps          [edi], xmm2
            movaps          [edi+16], xmm4
            movaps          [edi+32], xmm3
            movaps          [edi+48], xmm0
            add             esi, 16
            add             edi, 64
            sub             ecx, 1
            jnz             loop_4
            
            mov             esi, src2
            mov             ecx, xloopcount
            add             esi, 32
            mov             src2, esi
            sub             ecx, 1
            jnz             xloop_1
        }
        xwork2 = xwork + 48 * width;
        __asm
        {
            mov             edx, xwork2
            movaps          xmm0, [edx-96]
            movaps          xmm1, [edx-80]
            movaps          xmm2, [edx-64]
            movaps          [edx], xmm0
            movaps          [edx+16], xmm1
            movaps          [edx+32], xmm2
        }
        xwork2 = xwork;
        for(int x=0; x<width; x+=160)
        {
            int xloop1;
            if (width - x > 160) xloop1 = 80;
            else xloop1 = (width - x) / 2;
            
            if (x!=0)
            {
                __asm
                {
                    movaps          xmm7, predict
                    movaps          xmm6, update
                    mov             esi, xwork2
                    mov             ecx, xloop1
                align 16
                loop_5:
                    movaps          xmm0, [esi]
                    movaps          xmm1, [esi+16]
                    movaps          xmm2, [esi+32]
                    movaps          xmm3, [esi+96]
                    movaps          xmm4, [esi+112]
                    movaps          xmm5, [esi+128]
                    addps           xmm3, xmm0
                    addps           xmm4, xmm1
                    addps           xmm5, xmm2
                    mulps           xmm3, xmm7
                    mulps           xmm4, xmm7
                    mulps           xmm5, xmm7
                    addps           xmm3, [esi+48]
                    addps           xmm4, [esi+64]
                    addps           xmm5, [esi+80]
                    movaps          [esi+48], xmm3
                    movaps          [esi+64], xmm4
                    movaps          [esi+80], xmm5
                    addps           xmm3, [esi-48]
                    addps           xmm4, [esi-32]
                    addps           xmm5, [esi-16]
                    mulps           xmm3, xmm6
                    mulps           xmm4, xmm6
                    mulps           xmm5, xmm6
                    addps           xmm3, xmm0
                    addps           xmm4, xmm1
                    addps           xmm5, xmm2
                    movaps          [esi], xmm3
                    movaps          [esi+16], xmm4
                    movaps          [esi+32], xmm5
                    add             esi, 96
                    sub             ecx, 1
                    jnz             loop_5
                }
            }
            else
            {
                __asm
                {
                    movaps          xmm7, predict
                    movaps          xmm6, update
                    mov             esi, xwork2
                    mov             ecx, xloop1
                    movaps          xmm0, [esi]
                    movaps          xmm1, [esi+16]
                    movaps          xmm2, [esi+32]
                    addps           xmm0, [esi+96]
                    addps           xmm1, [esi+112]
                    addps           xmm2, [esi+128]
                    mulps           xmm0, xmm7
                    mulps           xmm1, xmm7
                    mulps           xmm2, xmm7
                    addps           xmm0, [esi+48]
                    addps           xmm1, [esi+64]
                    addps           xmm2, [esi+80]
                    movaps          [esi-48], xmm0
                    movaps          [esi-32], xmm1
                    movaps          [esi-16], xmm2
                align 16
                loop_6:
                    movaps          xmm0, [esi]
                    movaps          xmm1, [esi+16]
                    movaps          xmm2, [esi+32]
                    movaps          xmm3, [esi+96]
                    movaps          xmm4, [esi+112]
                    movaps          xmm5, [esi+128]
                    addps           xmm3, xmm0
                    addps           xmm4, xmm1
                    addps           xmm5, xmm2
                    mulps           xmm3, xmm7
                    mulps           xmm4, xmm7
                    mulps           xmm5, xmm7
                    addps           xmm3, [esi+48]
                    addps           xmm4, [esi+64]
                    addps           xmm5, [esi+80]
                    movaps          [esi+48], xmm3
                    movaps          [esi+64], xmm4
                    movaps          [esi+80], xmm5
                    addps           xmm3, [esi-48]
                    addps           xmm4, [esi-32]
                    addps           xmm5, [esi-16]
                    mulps           xmm3, xmm6
                    mulps           xmm4, xmm6
                    mulps           xmm5, xmm6
                    addps           xmm3, xmm0
                    addps           xmm4, xmm1
                    addps           xmm5, xmm2
                    movaps          [esi], xmm3
                    movaps          [esi+16], xmm4
                    movaps          [esi+32], xmm5
                    add             esi, 96
                    sub             ecx, 1
                    jnz             loop_6
                }
            }
            
            BYTE* xwork3 = xwork2;
            BYTE* dest3 = dest2;
            __asm
            {
                mov             ebx, 2
                mov             esi, xwork3
                mov             edi, dest3
            align 16
            loop_7:
                mov             edx, offsety
                mov             ecx, xloop1
                add             edx, edi
            align 16
            loop_8:
                movlps          xmm0, [esi]
                movlps          xmm1, [esi+16]
                movlps          xmm2, [esi+32]
                movlps          xmm3, [esi+96]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi], xmm0
                movntps         [edx], xmm2
                movlps          xmm0, [esi+112]
                movlps          xmm1, [esi+128]
                movlps          xmm2, [esi+192]
                movlps          xmm3, [esi+208]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi+16], xmm0
                movntps         [edx+16], xmm2
                movlps          xmm0, [esi+224]
                movlps          xmm1, [esi+288]
                movlps          xmm2, [esi+304]
                movlps          xmm3, [esi+320]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi+32], xmm0
                movntps         [edx+32], xmm2
                add             esi, 384
                add             edi, 48
                add             edx, 48
                sub             ecx, 4
                jnle            loop_8
                
                mov             esi, xwork3
                mov             edi, dest3
                mov             edx, offsety
                add             esi, 48
                add             edi, offsetx
                mov             ecx, xloop1
                add             edx, edi
            align 16
            loop_9:
                movlps          xmm0, [esi]
                movlps          xmm1, [esi+16]
                movlps          xmm2, [esi+32]
                movlps          xmm3, [esi+96]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi], xmm0
                movntps         [edx], xmm2
                movlps          xmm0, [esi+112]
                movlps          xmm1, [esi+128]
                movlps          xmm2, [esi+192]
                movlps          xmm3, [esi+208]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi+16], xmm0
                movntps         [edx+16], xmm2
                movlps          xmm0, [esi+224]
                movlps          xmm1, [esi+288]
                movlps          xmm2, [esi+304]
                movlps          xmm3, [esi+320]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi+32], xmm0
                movntps         [edx+32], xmm2
                add             esi, 384
                add             edi, 48
                add             edx, 48
                sub             ecx, 4
                jnle            loop_9
                
                mov             edi, dest3
                mov             esi, xwork3
                add             edi, dest_bpl
                add             esi, 8
                mov             dest3, edi
                mov             xwork3, esi
                sub             ebx, 1
                jnz             loop_7
            }
            xwork2 += 160 * 48;
            dest2 += 80 * 12;
        }
    }
}

void fwt53_LL(int thread_id,int thread_num,void *param1, void* param2)
{
    WAVELET_PARAM* prm = (WAVELET_PARAM*)param1;
    int width = (prm->srcwidth + 1) & ~1;
    int height = prm->srcheight;
    BYTE* src = prm->src;
    BYTE* dest = prm->dest;
    BYTE* ywork = work + worksize * thread_id;
    BYTE* xwork = ywork + 64 * (8 + 2 + 2);
    LONG* atomic_counter = (LONG*)(&prm->atomic_counter);
    int src_bpl = prm->src_bpl;
    int dest_bpl = prm->dest_bpl;
    int maxblock = (height + 7) / 8;
    while (TRUE)
    {
        int block = InterlockedIncrement(atomic_counter) - 1;
        if (block >= maxblock) break;
        int y0, y1, y2;
        y1 = block * 8;
        y0 = y1 - 2;
        y2 = y1 + 9;
        int yloop1, yloop2, yloop3;
        yloop2 = y2 - y0;
        if (y0 < 0)
        {
            yloop1 = 2;
            yloop2 -= 2;
        }
        else
        {
            yloop1 = 0;
        }
        if (y2 > height)
        {
            yloop3 = y2 - height;
            yloop2 -= yloop3;
        }
        else
        {
            yloop3 = 0;
        }

        int xloopcount = (width * 3 + 15) / 16;
        BYTE* src2 = src + (y0 + yloop1) * src_bpl;
        BYTE* dest2 = dest + y1 * dest_bpl / 2;
        BYTE* ywork2 = ywork + yloop1 * 64;
        BYTE* xwork2;
        __asm
        {
            mov             ecx, xloopcount
            mov             edi, xwork
            mov             eax, src_bpl
            mov             esi, src2
        align 16
        xloop_1:
            mov             xloopcount, ecx
            mov             xwork2, edi
            mov             edi, ywork2
            mov             ecx, yloop2
            
        align 16
        loop_1:
            movdqa          xmm1, [esi]
            movdqa          xmm3, [esi+16]
            punpcklwd       xmm0, xmm1
            punpckhwd       xmm1, xmm1
            punpcklwd       xmm2, xmm3
            punpckhwd       xmm3, xmm3
            psrad           xmm0, 16
            psrad           xmm1, 16
            psrad           xmm2, 16
            psrad           xmm3, 16
            cvtdq2ps        xmm0, xmm0
            cvtdq2ps        xmm1, xmm1
            cvtdq2ps        xmm2, xmm2
            cvtdq2ps        xmm3, xmm3
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
            movaps          [edi+48], xmm3
            add             esi, eax
            add             edi, 64
            sub             ecx, 1
            jnz             loop_1
            
            mov             ecx, yloop3
            test            ecx, ecx
            jz              loop_2_end
            sub             esi, eax
            sub             esi, eax
        align 16
        loop_2:
            movdqa          xmm1, [esi]
            movdqa          xmm3, [esi+16]
            punpcklwd       xmm0, xmm1
            punpckhwd       xmm1, xmm1
            punpcklwd       xmm2, xmm3
            punpckhwd       xmm3, xmm3
            psrad           xmm0, 16
            psrad           xmm1, 16
            psrad           xmm2, 16
            psrad           xmm3, 16
            cvtdq2ps        xmm0, xmm0
            cvtdq2ps        xmm1, xmm1
            cvtdq2ps        xmm2, xmm2
            cvtdq2ps        xmm3, xmm3
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
            movaps          [edi+48], xmm3
            sub             esi, eax
            add             edi, 64
            sub             ecx, 1
            jnz             loop_2
        loop_2_end:
            
            mov             ecx, yloop1
            test            ecx, ecx
            jz              padding_end
            mov             edi, ywork2
            movaps          xmm0, [edi+64]
            movaps          xmm1, [edi+80]
            movaps          xmm2, [edi+96]
            movaps          xmm3, [edi+112]
            movaps          [edi-64 ], xmm0
            movaps          [edi-48 ], xmm1
            movaps          [edi-32 ], xmm2
            movaps          [edi-16 ], xmm3
            movaps          xmm0, [edi+128]
            movaps          xmm1, [edi+144]
            movaps          xmm2, [edi+160]
            movaps          xmm3, [edi+176]
            movaps          [edi-128 ], xmm0
            movaps          [edi-112 ], xmm1
            movaps          [edi-96  ], xmm2
            movaps          [edi-80  ], xmm3
        padding_end:
            
            movaps          xmm7, predict
            movaps          xmm6, update
            mov             esi, ywork
            mov             edi, xwork2
            mov             ecx, 4
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            addps           xmm0, [esi+128]
            addps           xmm1, [esi+144]
            mulps           xmm0, xmm7
            mulps           xmm1, xmm7
            addps           xmm0, [esi+64]
            addps           xmm1, [esi+80]
            add             esi, 128
        align 16
        loop_3:
            movaps          xmm2, [esi]
            movaps          xmm3, [esi+16]
            movaps          xmm4, [esi+128]
            movaps          xmm5, [esi+144]
            addps           xmm4, xmm2
            addps           xmm5, xmm3
            mulps           xmm4, xmm7
            mulps           xmm5, xmm7
            addps           xmm4, [esi+64]
            addps           xmm5, [esi+80]
            addps           xmm0, xmm4
            addps           xmm1, xmm5
            mulps           xmm0, xmm6
            mulps           xmm1, xmm6
            addps           xmm2, xmm0
            addps           xmm3, xmm1
            movaps          xmm0, xmm4
            movaps          xmm1, xmm5
            movaps          [esi], xmm2
            movaps          [esi+16], xmm3
            add             esi, 128
            sub             ecx, 1
            jnz             loop_3
            
            sub             esi, 128*5-32
            mov             ecx, 4
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            addps           xmm0, [esi+128]
            addps           xmm1, [esi+144]
            mulps           xmm0, xmm7
            mulps           xmm1, xmm7
            addps           xmm0, [esi+64]
            addps           xmm1, [esi+80]
            add             esi, 128
        align 16
        loop_4:
            movaps          xmm2, [esi]
            movaps          xmm3, [esi+16]
            movaps          xmm4, [esi+128]
            movaps          xmm5, [esi+144]
            addps           xmm4, xmm2
            addps           xmm5, xmm3
            mulps           xmm4, xmm7
            mulps           xmm5, xmm7
            addps           xmm4, [esi+64]
            addps           xmm5, [esi+80]
            addps           xmm0, xmm4
            addps           xmm1, xmm5
            mulps           xmm0, xmm6
            mulps           xmm1, xmm6
            addps           xmm2, xmm0
            addps           xmm3, xmm1
            movaps          xmm0, xmm4
            movaps          xmm1, xmm5
            movaps          [esi], xmm2
            movaps          [esi+16], xmm3
            add             esi, 128
            sub             ecx, 1
            jnz             loop_4
            
            sub             esi, 128*4+32
            mov             ecx, 4
        align 16
        loop_5:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+128]
            movaps          xmm2, [esi+256]
            movaps          xmm3, [esi+384]
            movaps          xmm4, xmm0
            movaps          xmm5, xmm1
            unpcklps        xmm4, xmm2
            unpckhps        xmm0, xmm2
            unpcklps        xmm5, xmm3
            unpckhps        xmm1, xmm3
            movaps          xmm2, xmm4
            movaps          xmm3, xmm0
            unpcklps        xmm2, xmm5
            unpckhps        xmm4, xmm5
            unpcklps        xmm3, xmm1
            unpckhps        xmm0, xmm1
            movaps          [edi], xmm2
            movaps          [edi+16], xmm4
            movaps          [edi+32], xmm3
            movaps          [edi+48], xmm0
            add             esi, 16
            add             edi, 64
            sub             ecx, 1
            jnz             loop_5
            
            mov             esi, src2
            mov             ecx, xloopcount
            add             esi, 32
            mov             src2, esi
            sub             ecx, 1
            jnz             xloop_1
        }
        xwork2 = xwork + 48 * width;
        __asm
        {
            mov             edx, xwork2
            movaps          xmm0, [edx-96]
            movaps          xmm1, [edx-96+16]
            movaps          xmm2, [edx-96+32]
            movaps          [edx], xmm0
            movaps          [edx+16], xmm1
            movaps          [edx+32], xmm2
        }
        xwork2 = xwork;
        
        for(int x=0; x<width; x+=160)
        {
            int xloop1;
            if (width - x > 160) xloop1 = 80;
            else xloop1 = (width - x) / 2;
            
            if (x!=0)
            {
                __asm
                {
                    movaps          xmm7, predict
                    movaps          xmm6, update
                    mov             esi, xwork2
                    mov             ecx, xloop1
                    movaps          xmm3, [esi-48]
                    movaps          xmm4, [esi-32]
                    movaps          xmm5, [esi-16]
                align 16
                loop_6:
                    movaps          xmm0, [esi]
                    movaps          xmm1, [esi+16]
                    movaps          xmm2, [esi+32]
                    addps           xmm0, [esi+96]
                    addps           xmm1, [esi+112]
                    addps           xmm2, [esi+128]
                    mulps           xmm0, xmm7
                    mulps           xmm1, xmm7
                    mulps           xmm2, xmm7
                    addps           xmm0, [esi+48]
                    addps           xmm1, [esi+64]
                    addps           xmm2, [esi+80]
                    addps           xmm3, xmm0
                    addps           xmm4, xmm1
                    addps           xmm5, xmm2
                    mulps           xmm3, xmm6
                    mulps           xmm4, xmm6
                    mulps           xmm5, xmm6
                    addps           xmm3, [esi]
                    addps           xmm4, [esi+16]
                    addps           xmm5, [esi+32]
                    movaps          [esi], xmm3
                    movaps          [esi+16], xmm4
                    movaps          [esi+32], xmm5
                    movaps          xmm3, xmm0
                    movaps          xmm4, xmm1
                    movaps          xmm5, xmm2
                    add             esi, 96
                    sub             ecx, 1
                    jnz             loop_6
                    movaps          [esi-48], xmm3
                    movaps          [esi-32], xmm4
                    movaps          [esi-16], xmm5
                }
            }
            else
            {
                __asm
                {
                    movaps          xmm7, predict
                    movaps          xmm6, update
                    mov             esi, xwork2
                    mov             ecx, xloop1
                    movaps          xmm3, [esi]
                    movaps          xmm4, [esi+16]
                    movaps          xmm5, [esi+32]
                    addps           xmm3, [esi+96]
                    addps           xmm4, [esi+112]
                    addps           xmm5, [esi+128]
                    mulps           xmm3, xmm7
                    mulps           xmm4, xmm7
                    mulps           xmm5, xmm7
                    addps           xmm3, [esi+48]
                    addps           xmm4, [esi+64]
                    addps           xmm5, [esi+80]
                align 16
                loop_7:
                    movaps          xmm0, [esi]
                    movaps          xmm1, [esi+16]
                    movaps          xmm2, [esi+32]
                    addps           xmm0, [esi+96]
                    addps           xmm1, [esi+112]
                    addps           xmm2, [esi+128]
                    mulps           xmm0, xmm7
                    mulps           xmm1, xmm7
                    mulps           xmm2, xmm7
                    addps           xmm0, [esi+48]
                    addps           xmm1, [esi+64]
                    addps           xmm2, [esi+80]
                    addps           xmm3, xmm0
                    addps           xmm4, xmm1
                    addps           xmm5, xmm2
                    mulps           xmm3, xmm6
                    mulps           xmm4, xmm6
                    mulps           xmm5, xmm6
                    addps           xmm3, [esi]
                    addps           xmm4, [esi+16]
                    addps           xmm5, [esi+32]
                    movaps          [esi], xmm3
                    movaps          [esi+16], xmm4
                    movaps          [esi+32], xmm5
                    movaps          xmm3, xmm0
                    movaps          xmm4, xmm1
                    movaps          xmm5, xmm2
                    add             esi, 96
                    sub             ecx, 1
                    jnz             loop_7
                    movaps          [esi-48], xmm3
                    movaps          [esi-32], xmm4
                    movaps          [esi-16], xmm5
                }
            }
            
            BYTE* xwork3 = xwork2;
            BYTE* dest3 = dest2;
            __asm
            {
                mov             ebx, 2
                mov             esi, xwork3
                mov             edi, dest3
                mov             eax, dest_bpl
            loop_8:
                mov             ecx, xloop1
            align 16
            loop_9:
                movlps          xmm0, [esi]
                movlps          xmm1, [esi+16]
                movlps          xmm2, [esi+32]
                movlps          xmm3, [esi+96]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi], xmm0
                movntps         [edi+eax], xmm2
                movlps          xmm0, [esi+112]
                movlps          xmm1, [esi+128]
                movlps          xmm2, [esi+192]
                movlps          xmm3, [esi+208]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi+16], xmm0
                movntps         [edi+eax+16], xmm2
                movlps          xmm0, [esi+224]
                movlps          xmm1, [esi+288]
                movlps          xmm2, [esi+304]
                movlps          xmm3, [esi+320]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi+32], xmm0
                movntps         [edi+eax+32], xmm2
                add             esi, 384
                add             edi, 48
                sub             ecx, 4
                jnle            loop_9
                
                mov             edi, dest3
                mov             esi, xwork3
                lea             edi, [edi+eax*2]
                add             esi, 8
                mov             dest3, edi
                mov             xwork3, esi
                sub             ebx, 1
                jnz             loop_8
            }
            xwork2 += 160 * 48;
            dest2 += 80 * 12;
        }
    }
}

void iwt53(int thread_id,int thread_num,void *param1, void* param2)
{
    WAVELET_PARAM* prm = (WAVELET_PARAM*)param1;
    int width = prm->destwidth;
    int height = (prm->destheight+3)&~3;
    int halfw = (prm->destwidth + 1) / 2;
    int halfh = height / 2;
    BYTE* src = prm->src;
    BYTE* dest = prm->dest;
    BYTE* ywork = work + worksize * thread_id;
    BYTE* xwork = ywork + 64 * (4 + 2 + 2);
    LONG* atomic_counter = (LONG*)(&prm->atomic_counter);
    int src_bpl = prm->src_bpl;
    int dest_bpl = prm->dest_bpl;
    int maxblock = (height+3) / 4;
    int v_hi = (prm->srcheight / 2) * src_bpl;
    int h_hi = (prm->srcwidth / 2) * 12;
    int xworkhalf = ((((halfw + 15) &~15) + 1) * 48 +127) &~127;
    int xloop1 = (halfw * 3 + 15) / 16;
    while (TRUE)
    {
        int block = InterlockedIncrement(atomic_counter) - 1;
        if (block >= maxblock) break;
        int y0, y1, y2;
        y1 = block * 2;
        y0 = y1 - 1;
        y2 = y1 + 3;
        int yloop1, yloop2, yloop3;
        yloop2 = y2 - y0;
        if (y0 < 0)
        {
            yloop1 = 1;
            yloop2 -= 1;
        }
        else
        {
            yloop1 = 0;
        }
        if (y2 > halfh)
        {
            yloop3 = y2 - halfh;
            yloop2 -= yloop3;
        }
        else
        {
            yloop3 = 0;
        }

        BYTE* src2 = src + (y0 + yloop1) * src_bpl;
        BYTE* dest2 = dest + y1 * dest_bpl * 2;
        BYTE* ywork2 = ywork + yloop1 * 128;
        BYTE* xwork2 = xwork;
        BYTE* src3 = src2;
        int xloop2;
        __asm
        {
            mov             ecx, xloop1
            mov             esi, src3
            mov             eax, src_bpl
            mov             edx, v_hi
            mov             ebx, 2
        align 16
        xloop_1:
            mov             xloop2, ecx
            mov             edi, ywork2
            mov             ecx, yloop2
        align 16
        loop_1:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            movaps          xmm2, [esi+32]
            movaps          xmm3, [esi+48]
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
            movaps          [edi+48], xmm3
            movaps          xmm0, [esi+edx]
            movaps          xmm1, [esi+edx+16]
            movaps          xmm2, [esi+edx+32]
            movaps          xmm3, [esi+edx+48]
            movaps          [edi+64], xmm0
            movaps          [edi+80], xmm1
            movaps          [edi+96], xmm2
            movaps          [edi+112], xmm3
            add             esi, eax
            add             edi, 128
            sub             ecx, 1
            jnz             loop_1
            
            mov             ecx, yloop3
            test            ecx, ecx
            jz              loop_2_end
            lea             esi, [edi-192]
        align 16
        loop_2:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            movaps          xmm2, [esi+32]
            movaps          xmm3, [esi+48]
            movaps          [edi+64], xmm0
            movaps          [edi+80], xmm1
            movaps          [edi+96], xmm2
            movaps          [edi+112], xmm3
            movaps          xmm0, [esi+64]
            movaps          xmm1, [esi+80]
            movaps          xmm2, [esi+96]
            movaps          xmm3, [esi+112]
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
            movaps          [edi+48], xmm3
            sub             esi, 128
            add             edi, 128
            sub             ecx, 1
            jnz             loop_2
            loop_2_end:
            
            mov             ecx, yloop1
            test            ecx, ecx
            jz              padding_end
            mov             edi, ywork2
            mov             esi, edi
            movaps          xmm0, [edi+64]
            movaps          xmm1, [edi+80]
            movaps          xmm2, [edi+96]
            movaps          xmm3, [esi+112]
            movaps          [edi-64], xmm0
            movaps          [edi-48], xmm1
            movaps          [edi-32], xmm2
            movaps          [edi-16], xmm3
            movaps          xmm0, [esi+128]
            movaps          xmm1, [esi+144]
            movaps          xmm2, [esi+160]
            movaps          xmm3, [esi+176]
            movaps          [edi-128], xmm0
            movaps          [edi-112], xmm1
            movaps          [edi-96], xmm2
            movaps          [edi-80], xmm3
        padding_end:
            
            movaps          xmm7, i_update
            movaps          xmm6, i_predict
            mov             esi, ywork
            mov             edi, xwork2
            mov             ecx, 2
            add             esi, 64
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            movaps          xmm2, [esi+32]
            movaps          xmm3, [esi+48]
            addps           xmm0, [esi+128]
            addps           xmm1, [esi+144]
            addps           xmm2, [esi+160]
            addps           xmm3, [esi+176]
            mulps           xmm0, xmm7
            mulps           xmm1, xmm7
            mulps           xmm2, xmm7
            mulps           xmm3, xmm7
            addps           xmm0, [esi+64]
            addps           xmm1, [esi+80]
            addps           xmm2, [esi+96]
            addps           xmm3, [esi+112]
            movaps          [esi+64], xmm0
            movaps          [esi+80], xmm1
            movaps          [esi+96], xmm2
            movaps          [esi+112], xmm3
            add             esi, 128
        align 16
        loop_3:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            movaps          xmm2, [esi+32]
            movaps          xmm3, [esi+48]
            addps           xmm0, [esi+128]
            addps           xmm1, [esi+144]
            addps           xmm2, [esi+160]
            addps           xmm3, [esi+176]
            mulps           xmm0, xmm7
            mulps           xmm1, xmm7
            mulps           xmm2, xmm7
            mulps           xmm3, xmm7
            addps           xmm0, [esi+64]
            addps           xmm1, [esi+80]
            addps           xmm2, [esi+96]
            addps           xmm3, [esi+112]
            movaps          [esi+64], xmm0
            movaps          [esi+80], xmm1
            movaps          [esi+96], xmm2
            movaps          [esi+112], xmm3
            addps           xmm0, [esi-64]
            addps           xmm1, [esi-48]
            addps           xmm2, [esi-32]
            addps           xmm3, [esi-16]
            mulps           xmm0, xmm6
            mulps           xmm1, xmm6
            mulps           xmm2, xmm6
            mulps           xmm3, xmm6
            addps           xmm0, [esi]
            addps           xmm1, [esi+16]
            addps           xmm2, [esi+32]
            addps           xmm3, [esi+48]
            movaps          [esi], xmm0
            movaps          [esi+16], xmm1
            movaps          [esi+32], xmm2
            movaps          [esi+48], xmm3
            add             esi, 128
            sub             ecx, 1
            jnz             loop_3
            
            sub             esi, 64*5
            mov             ecx, 4
        align 16
        loop_4:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+64]
            movaps          xmm2, [esi+128]
            movaps          xmm3, [esi+192]
            movaps          xmm4, xmm0
            movaps          xmm5, xmm1
            unpcklps        xmm0, xmm2
            unpckhps        xmm4, xmm2
            unpcklps        xmm1, xmm3
            unpckhps        xmm5, xmm3
            movaps          xmm2, xmm0
            movaps          xmm3, xmm4
            unpcklps        xmm0, xmm1
            unpckhps        xmm2, xmm1
            unpcklps        xmm4, xmm5
            unpckhps        xmm3, xmm5
            movaps          [edi], xmm0
            movaps          [edi+16], xmm2
            movaps          [edi+32], xmm4
            movaps          [edi+48], xmm3
            add             esi, 16
            add             edi, 64
            sub             ecx, 1
            jnz             loop_4
            
            mov             esi, src3
            mov             ecx, xloop2
            add             esi, 64
            mov             xwork2, edi
            mov             src3, esi
            sub             ecx, 1
            jnz             xloop_1
            
            sub             ebx, 1
            jz              xloop_1_end
            
            mov             esi, src2
            mov             edi, xwork
            add             esi, h_hi
            add             edi, xworkhalf
            mov             src3, esi
            mov             xwork2, edi
            mov             ecx, xloop1
            jmp             xloop_1
        xloop_1_end:
        }

        xwork2 = xwork + 48 * halfw;
        BYTE* xwork3 = xwork + 48 * halfw + xworkhalf;
        __asm
        {
            mov             esi, xwork2
            mov             edi, xwork3
            movaps          xmm0, [esi-48]
            movaps          xmm1, [esi-32]
            movaps          xmm2, [esi-16]
            movaps          [esi], xmm0
            movaps          [esi+16], xmm1
            movaps          [esi+32], xmm2
            movaps          xmm0, [edi-96]
            movaps          xmm1, [edi-80]
            movaps          xmm2, [edi-64]
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
        }
        
        xwork2 = xwork;
        for(int x=0; x<halfw; x+=80)
        {
            int xloop3;
            if (halfw - x > 80) xloop3 = 80;
            else xloop3 = halfw - x;
            if(x!=0)
            {
                __asm
                {
                    movaps          xmm7, i_update
                    movaps          xmm6, i_predict
                    mov             esi, xwork2
                    mov             edx, xworkhalf
                    mov             ecx, xloop3
                align 16
                loop_5:
                    movaps          xmm0, [esi+edx]
                    movaps          xmm1, [esi+edx+16]
                    movaps          xmm2, [esi+edx+32]
                    movaps          xmm3, [esi+edx+48]
                    movaps          xmm4, [esi+edx+64]
                    movaps          xmm5, [esi+edx+80]
                    addps           xmm3, xmm0
                    addps           xmm4, xmm1
                    addps           xmm5, xmm2
                    mulps           xmm3, xmm7
                    mulps           xmm4, xmm7
                    mulps           xmm5, xmm7
                    addps           xmm3, [esi+48]
                    addps           xmm4, [esi+64]
                    addps           xmm5, [esi+80]
                    movaps          [esi+48], xmm3
                    movaps          [esi+64], xmm4
                    movaps          [esi+80], xmm5
                    addps           xmm3, [esi]
                    addps           xmm4, [esi+16]
                    addps           xmm5, [esi+32]
                    mulps           xmm3, xmm6
                    mulps           xmm4, xmm6
                    mulps           xmm5, xmm6
                    addps           xmm3, xmm0
                    addps           xmm4, xmm1
                    addps           xmm5, xmm2
                    movaps          [esi+edx], xmm3
                    movaps          [esi+edx+16], xmm4
                    movaps          [esi+edx+32], xmm5
                    add             esi, 48
                    sub             ecx, 1
                    jnz             loop_5
                }
            }
            else
            {
                __asm
                {
                    movaps          xmm7, i_update
                    movaps          xmm6, i_predict
                    mov             esi, xwork2
                    mov             edx, xworkhalf
                    mov             ecx, xloop3
                    movaps          xmm0, [esi+edx]
                    movaps          xmm1, [esi+edx+16]
                    movaps          xmm2, [esi+edx+32]
                    addps           xmm0, xmm0
                    addps           xmm1, xmm1
                    addps           xmm2, xmm2
                    mulps           xmm0, xmm7
                    mulps           xmm1, xmm7
                    mulps           xmm2, xmm7
                    addps           xmm0, [esi]
                    addps           xmm1, [esi+16]
                    addps           xmm2, [esi+32]
                    movaps          [esi], xmm0
                    movaps          [esi+16], xmm1
                    movaps          [esi+32], xmm2
                align 16
                loop_6:
                    movaps          xmm0, [esi+edx]
                    movaps          xmm1, [esi+edx+16]
                    movaps          xmm2, [esi+edx+32]
                    movaps          xmm3, [esi+edx+48]
                    movaps          xmm4, [esi+edx+64]
                    movaps          xmm5, [esi+edx+80]
                    addps           xmm3, xmm0
                    addps           xmm4, xmm1
                    addps           xmm5, xmm2
                    mulps           xmm3, xmm7
                    mulps           xmm4, xmm7
                    mulps           xmm5, xmm7
                    addps           xmm3, [esi+48]
                    addps           xmm4, [esi+64]
                    addps           xmm5, [esi+80]
                    movaps          [esi+48], xmm3
                    movaps          [esi+64], xmm4
                    movaps          [esi+80], xmm5
                    addps           xmm3, [esi]
                    addps           xmm4, [esi+16]
                    addps           xmm5, [esi+32]
                    mulps           xmm3, xmm6
                    mulps           xmm4, xmm6
                    mulps           xmm5, xmm6
                    addps           xmm3, xmm0
                    addps           xmm4, xmm1
                    addps           xmm5, xmm2
                    movaps          [esi+edx], xmm3
                    movaps          [esi+edx+16], xmm4
                    movaps          [esi+edx+32], xmm5
                    add             esi, 48
                    sub             ecx, 1
                    jnz             loop_6
                }
            }
            
            BYTE* xwork3 = xwork2;
            BYTE* dest3 = dest2;
            __asm
            {
                mov             ebx, 2
                mov             esi, xwork3
                mov             edi, dest3
                mov             edx, xworkhalf
                mov             eax, dest_bpl
            align 16
            loop_7:
                mov             ecx, xloop3
                
            align 16
            loop_8:
                movlps          xmm0, [esi]
                movlps          xmm1, [esi+16]
                movlps          xmm2, [esi+32]
                movlps          xmm3, [esi+edx]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movlps          xmm1, [esi+edx+16]
                movlps          xmm3, [esi+edx+32]
                movlps          xmm4, [esi+48]
                movlps          xmm5, [esi+64]
                unpcklps        xmm1, xmm4
                unpcklps        xmm3, xmm5
                movaps          xmm4, xmm1
                unpcklps        xmm1, xmm3
                unpckhps        xmm4, xmm3
                cvtps2dq        xmm0, xmm0
                cvtps2dq        xmm2, xmm2
                cvtps2dq        xmm1, xmm1
                cvtps2dq        xmm4, xmm4
                packssdw        xmm0, xmm1
                packssdw        xmm2, xmm4
                movntdq         [edi], xmm0
                movntdq         [edi+eax], xmm2
                
                movlps          xmm0, [esi+80]
                movlps          xmm1, [esi+edx+48]
                movlps          xmm2, [esi+edx+64]
                movlps          xmm3, [esi+edx+80]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movlps          xmm1, [esi+96]
                movlps          xmm3, [esi+112]
                movlps          xmm4, [esi+128]
                movlps          xmm5, [esi+edx+96]
                unpcklps        xmm1, xmm4
                unpcklps        xmm3, xmm5
                movaps          xmm4, xmm1
                unpcklps        xmm1, xmm3
                unpckhps        xmm4, xmm3
                cvtps2dq        xmm0, xmm0
                cvtps2dq        xmm2, xmm2
                cvtps2dq        xmm1, xmm1
                cvtps2dq        xmm4, xmm4
                packssdw        xmm0, xmm1
                packssdw        xmm2, xmm4
                movntdq         [edi+16], xmm0
                movntdq         [edi+eax+16], xmm2
                
                movlps          xmm0, [esi+edx+112]
                movlps          xmm1, [esi+edx+128]
                movlps          xmm2, [esi+144]
                movlps          xmm3, [esi+160]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movlps          xmm1, [esi+176]
                movlps          xmm3, [esi+edx+144]
                movlps          xmm4, [esi+edx+160]
                movlps          xmm5, [esi+edx+176]
                unpcklps        xmm1, xmm4
                unpcklps        xmm3, xmm5
                movaps          xmm4, xmm1
                unpcklps        xmm1, xmm3
                unpckhps        xmm4, xmm3
                cvtps2dq        xmm0, xmm0
                cvtps2dq        xmm2, xmm2
                cvtps2dq        xmm1, xmm1
                cvtps2dq        xmm4, xmm4
                packssdw        xmm0, xmm1
                packssdw        xmm2, xmm4
                movntdq         [edi+32], xmm0
                movntdq         [edi+eax+32], xmm2
                add             esi, 192
                add             edi, 48
                sub             ecx, 4
                jnle            loop_8
                
                mov             edi, dest3
                mov             esi, xwork3
                lea             edi, [edi+eax*2]
                add             esi, 8
                mov             dest3, edi
                mov             xwork3, esi
                sub             ebx, 1
                jnz             loop_7
            }
            xwork2 += 80 * 48;
            dest2 += 160 * 6;
        }
    }
}

void fwt53_luma(int thread_id,int thread_num,void *param1, void* param2)
{
    WAVELET_PARAM* prm = (WAVELET_PARAM*)param1;
    int width = (prm->srcwidth + 1) & ~1;
    int height = prm->srcheight;
    BYTE* src = prm->src;
    BYTE* dest = prm->dest;
    BYTE* ywork = work + worksize * thread_id;
    BYTE* xwork = ywork + 64 * (4 + 2 + 2);
    LONG* atomic_counter = (LONG*)(&prm->atomic_counter);
    int src_bpl = prm->src_bpl;
    int dest_bpl = prm->dest_bpl;
    
    int maxblock = (height + 3) / 4;
    int offsety = (prm->destheight / 2) * dest_bpl;
    int offsetx = (prm->destwidth / 2) * 4;
    while (TRUE)
    {
        int block = InterlockedIncrement(atomic_counter) - 1;
        if (block >= maxblock) break;
        int y0, y1, y2;
        y1 = block * 4;
        y0 = y1 - 2;
        y2 = y1 + 5;
        int yloop1, yloop2, yloop3;
        yloop2 = y2 - y0;
        if (y0 < 0)
        {
            yloop1 = 2;
            yloop2 -= 2;
        }
        else
        {
            yloop1 = 0;
        }
        if (y2 > height)
        {
            yloop3 = y2 - height;
            yloop2 -= yloop3;
        }
        else
        {
            yloop3 = 0;
        }

        int xloopcount = (width + 15) / 16;
        BYTE* src2 = src + (y0 + yloop1) * src_bpl;
        BYTE* dest2 = dest + y1 * dest_bpl / 2;
        BYTE* ywork2 = ywork + yloop1 * 64;
        BYTE* xwork2;
        __asm
        {
            mov             ecx, xloopcount
            mov             edi, xwork
            mov             eax, src_bpl
            mov             esi, src2
        align 16
        xloop_1:
            mov             xloopcount, ecx
            mov             xwork2, edi
            mov             edi, ywork2
            mov             ecx, yloop2
            
        align 16
        loop_1:
            pinsrw          xmm0, [esi], 1
            pinsrw          xmm0, [esi+6], 3
            pinsrw          xmm0, [esi+12], 5
            pinsrw          xmm0, [esi+18], 7
            pinsrw          xmm1, [esi+24], 1
            pinsrw          xmm1, [esi+30], 3
            pinsrw          xmm1, [esi+36], 5
            pinsrw          xmm1, [esi+42], 7
            pinsrw          xmm2, [esi+48], 1
            pinsrw          xmm2, [esi+54], 3
            pinsrw          xmm2, [esi+60], 5
            pinsrw          xmm2, [esi+66], 7
            pinsrw          xmm3, [esi+72], 1
            pinsrw          xmm3, [esi+78], 3
            pinsrw          xmm3, [esi+84], 5
            pinsrw          xmm3, [esi+90], 7
            psrad           xmm0, 16
            psrad           xmm1, 16
            psrad           xmm2, 16
            psrad           xmm3, 16
            cvtdq2ps        xmm0, xmm0
            cvtdq2ps        xmm1, xmm1
            cvtdq2ps        xmm2, xmm2
            cvtdq2ps        xmm3, xmm3
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
            movaps          [edi+48], xmm3
            add             esi, eax
            add             edi, 64
            sub             ecx, 1
            jnz             loop_1
            
            mov             ecx, yloop3
            test            ecx, ecx
            jz              loop_2_end
            sub             esi, eax
            sub             esi, eax
        align 16
        loop_2:
            pinsrw          xmm0, [esi], 1
            pinsrw          xmm0, [esi+6], 3
            pinsrw          xmm0, [esi+12], 5
            pinsrw          xmm0, [esi+18], 7
            pinsrw          xmm1, [esi+24], 1
            pinsrw          xmm1, [esi+30], 3
            pinsrw          xmm1, [esi+36], 5
            pinsrw          xmm1, [esi+42], 7
            pinsrw          xmm2, [esi+48], 1
            pinsrw          xmm2, [esi+54], 3
            pinsrw          xmm2, [esi+60], 5
            pinsrw          xmm2, [esi+66], 7
            pinsrw          xmm3, [esi+72], 1
            pinsrw          xmm3, [esi+78], 3
            pinsrw          xmm3, [esi+84], 5
            pinsrw          xmm3, [esi+90], 7
            psrad           xmm0, 16
            psrad           xmm1, 16
            psrad           xmm2, 16
            psrad           xmm3, 16
            cvtdq2ps        xmm0, xmm0
            cvtdq2ps        xmm1, xmm1
            cvtdq2ps        xmm2, xmm2
            cvtdq2ps        xmm3, xmm3
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
            movaps          [edi+48], xmm3
            sub             esi, eax
            add             edi, 64
            sub             ecx, 1
            jnz             loop_2
        loop_2_end:
            
            mov             ecx, yloop1
            test            ecx, ecx
            jz              padding_end
            mov             edi, ywork2
            movaps          xmm0, [edi+64]
            movaps          xmm1, [edi+80]
            movaps          xmm2, [edi+96]
            movaps          xmm3, [edi+112]
            movaps          [edi-64 ], xmm0
            movaps          [edi-48 ], xmm1
            movaps          [edi-32 ], xmm2
            movaps          [edi-16 ], xmm3
            movaps          xmm0, [edi+128]
            movaps          xmm1, [edi+144]
            movaps          xmm2, [edi+160]
            movaps          xmm3, [edi+176]
            movaps          [edi-128 ], xmm0
            movaps          [edi-112 ], xmm1
            movaps          [edi-96  ], xmm2
            movaps          [edi-80  ], xmm3
        padding_end:
            
            movaps          xmm7, predict
            movaps          xmm6, update
            mov             esi, ywork
            mov             edi, xwork2
            mov             ecx, 2
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            movaps          xmm2, [esi+32]
            movaps          xmm3, [esi+48]
            addps           xmm0, [esi+128]
            addps           xmm1, [esi+144]
            addps           xmm2, [esi+160]
            addps           xmm3, [esi+176]
            mulps           xmm0, xmm7
            mulps           xmm1, xmm7
            mulps           xmm2, xmm7
            mulps           xmm3, xmm7
            addps           xmm0, [esi+64]
            addps           xmm1, [esi+80]
            addps           xmm2, [esi+96]
            addps           xmm3, [esi+112]
            movaps          [esi+64], xmm0
            movaps          [esi+80], xmm1
            movaps          [esi+96], xmm2
            movaps          [esi+112], xmm3
            add             esi, 128
        align 16
        loop_3:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            movaps          xmm2, [esi+32]
            movaps          xmm3, [esi+48]
            addps           xmm0, [esi+128]
            addps           xmm1, [esi+144]
            addps           xmm2, [esi+160]
            addps           xmm3, [esi+176]
            mulps           xmm0, xmm7
            mulps           xmm1, xmm7
            mulps           xmm2, xmm7
            mulps           xmm3, xmm7
            addps           xmm0, [esi+64]
            addps           xmm1, [esi+80]
            addps           xmm2, [esi+96]
            addps           xmm3, [esi+112]
            movaps          [esi+64], xmm0
            movaps          [esi+80], xmm1
            movaps          [esi+96], xmm2
            movaps          [esi+112], xmm3
            addps           xmm0, [esi-64]
            addps           xmm1, [esi-48]
            addps           xmm2, [esi-32]
            addps           xmm3, [esi-16]
            mulps           xmm0, xmm6
            mulps           xmm1, xmm6
            mulps           xmm2, xmm6
            mulps           xmm3, xmm6
            addps           xmm0, [esi]
            addps           xmm1, [esi+16]
            addps           xmm2, [esi+32]
            addps           xmm3, [esi+48]
            movaps          [esi], xmm0
            movaps          [esi+16], xmm1
            movaps          [esi+32], xmm2
            movaps          [esi+48], xmm3
            add             esi, 128
            sub             ecx, 1
            jnz             loop_3
            
            sub             esi, 64*4
            mov             ecx, 4
        align 16
        loop_4:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+64]
            movaps          xmm2, [esi+128]
            movaps          xmm3, [esi+192]
            movaps          xmm4, xmm0
            movaps          xmm5, xmm1
            unpcklps        xmm4, xmm2
            unpckhps        xmm0, xmm2
            unpcklps        xmm5, xmm3
            unpckhps        xmm1, xmm3
            movaps          xmm2, xmm4
            movaps          xmm3, xmm0
            unpcklps        xmm2, xmm5
            unpckhps        xmm4, xmm5
            unpcklps        xmm3, xmm1
            unpckhps        xmm0, xmm1
            movaps          [edi], xmm2
            movaps          [edi+16], xmm4
            movaps          [edi+32], xmm3
            movaps          [edi+48], xmm0
            add             esi, 16
            add             edi, 64
            sub             ecx, 1
            jnz             loop_4
            
            mov             esi, src2
            mov             ecx, xloopcount
            add             esi, 96
            mov             src2, esi
            sub             ecx, 1
            jnz             xloop_1
        }
        xwork2 = xwork + 16 * width;
        __asm
        {
            mov             edx, xwork2
            movaps          xmm0, [edx-32]
            movaps          [edx], xmm0
        }
        xwork2 = xwork;
        for(int x=0; x<width; x+=160)
        {
            int xloop1;
            if (width - x > 160) xloop1 = 80;
            else xloop1 = (width - x) / 2;
            
            if (x!=0)
            {
                __asm
                {
                    movaps          xmm7, predict
                    movaps          xmm6, update
                    mov             esi, xwork2
                    mov             ecx, xloop1
                    
                    movaps          xmm4, [esi-16]
                    movaps          xmm5, [esi]
                    sub             ecx, 1
                    jz              loop_5_last
                align 16
                loop_5:
                    movaps          xmm0, [esi+32]
                    movaps          xmm1, [esi+64]
                    movaps          xmm2, xmm0
                    movaps          xmm3, xmm1
                    addps           xmm0, xmm5
                    addps           xmm1, xmm2
                    mulps           xmm0, xmm7
                    mulps           xmm1, xmm7
                    addps           xmm0, [esi+16]
                    addps           xmm1, [esi+48]
                    movaps          [esi+16], xmm0
                    movaps          [esi+48], xmm1
                    addps           xmm4, xmm0
                    addps           xmm0, xmm1
                    mulps           xmm4, xmm6
                    mulps           xmm0, xmm6
                    addps           xmm4, xmm5
                    addps           xmm0, xmm2
                    movaps          [esi], xmm4
                    movaps          [esi+32], xmm0
                    movaps          xmm4, xmm1
                    movaps          xmm5, xmm3
                    add             esi, 64
                    sub             ecx, 2
                    jnle            loop_5
                loop_5_last:
                    add             ecx, 1
                    jz              loop_5_end
                    
                    movaps          xmm0, [esi+32]
                    movaps          xmm1, [esi+16]
                    addps           xmm0, xmm5
                    mulps           xmm0, xmm7
                    addps           xmm1, xmm0
                    movaps          [esi+16], xmm1
                    addps           xmm4, xmm1
                    mulps           xmm4, xmm6
                    addps           xmm5, xmm4
                    movaps          [esi], xmm5
                loop_5_end:
                }
            }
            else
            {
                __asm
                {
                    movaps          xmm7, predict
                    movaps          xmm6, update
                    mov             esi, xwork2
                    mov             ecx, xloop1
                    
                    movaps          xmm0, [esi]
                    movaps          xmm4, [esi+16]
                    movaps          xmm2, [esi+32]
                    movaps          xmm5, xmm0
                    addps           xmm0, xmm2
                    mulps           xmm0, xmm7
                    addps           xmm4, xmm0
                    sub             ecx, 1
                    jz              loop_6_last
                align 16
                loop_6:
                    movaps          xmm0, [esi+32]
                    movaps          xmm1, [esi+64]
                    movaps          xmm2, xmm0
                    movaps          xmm3, xmm1
                    addps           xmm0, xmm5
                    addps           xmm1, xmm2
                    mulps           xmm0, xmm7
                    mulps           xmm1, xmm7
                    addps           xmm0, [esi+16]
                    addps           xmm1, [esi+48]
                    movaps          [esi+16], xmm0
                    movaps          [esi+48], xmm1
                    addps           xmm4, xmm0
                    addps           xmm0, xmm1
                    mulps           xmm4, xmm6
                    mulps           xmm0, xmm6
                    addps           xmm4, xmm5
                    addps           xmm0, xmm2
                    movaps          [esi], xmm4
                    movaps          [esi+32], xmm0
                    movaps          xmm4, xmm1
                    movaps          xmm5, xmm3
                    add             esi, 64
                    sub             ecx, 2
                    jnle            loop_6
                loop_6_last:
                    add             ecx, 1
                    jz              loop_6_end
                    
                    movaps          xmm0, [esi+32]
                    movaps          xmm1, [esi+16]
                    addps           xmm0, xmm5
                    mulps           xmm0, xmm7
                    addps           xmm1, xmm0
                    movaps          [esi+16], xmm1
                    addps           xmm4, xmm1
                    mulps           xmm4, xmm6
                    addps           xmm5, xmm4
                    movaps          [esi], xmm5
                loop_6_end:
                }
            }
            
            BYTE* xwork3 = xwork2;
            BYTE* dest3 = dest2;
            __asm
            {
                mov             ebx, 2
                mov             esi, xwork3
                mov             edi, dest3
            align 16
            loop_7:
                mov             edx, offsety
                mov             ecx, xloop1
                add             edx, edi
            align 16
            loop_8:
                movlps          xmm0, [esi]
                movlps          xmm1, [esi+32]
                movlps          xmm2, [esi+64]
                movlps          xmm3, [esi+96]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi], xmm0
                movntps         [edx], xmm2
                movlps          xmm0, [esi+128]
                movlps          xmm1, [esi+160]
                movlps          xmm2, [esi+192]
                movlps          xmm3, [esi+224]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi+16], xmm0
                movntps         [edx+16], xmm2
                add             esi, 256
                add             edi, 32
                add             edx, 32
                sub             ecx, 8
                jnle            loop_8
                
                mov             esi, xwork3
                mov             edi, dest3
                mov             edx, offsety
                add             esi, 16
                add             edi, offsetx
                mov             ecx, xloop1
                add             edx, edi
            align 16
            loop_9:
                movlps          xmm0, [esi]
                movlps          xmm1, [esi+32]
                movlps          xmm2, [esi+64]
                movlps          xmm3, [esi+96]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi], xmm0
                movntps         [edx], xmm2
                movlps          xmm0, [esi+128]
                movlps          xmm1, [esi+160]
                movlps          xmm2, [esi+192]
                movlps          xmm3, [esi+224]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi+16], xmm0
                movntps         [edx+16], xmm2
                add             esi, 256
                add             edi, 32
                add             edx, 32
                sub             ecx, 8
                jnle            loop_9
                
                mov             edi, dest3
                mov             esi, xwork3
                add             edi, dest_bpl
                add             esi, 8
                mov             dest3, edi
                mov             xwork3, esi
                sub             ebx, 1
                jnz             loop_7
            }
            xwork2 += 160 * 16;
            dest2 += 80 * 4;
        }
    }
}

void fwt53_LL_luma(int thread_id,int thread_num,void *param1, void* param2)
{
    WAVELET_PARAM* prm = (WAVELET_PARAM*)param1;
    int width = (prm->srcwidth + 1) & ~1;
    int height = prm->srcheight;
    BYTE* src = prm->src;
    BYTE* dest = prm->dest;
    BYTE* ywork = work + worksize * thread_id;
    BYTE* xwork = ywork + 64 * (8 + 2 + 2);
    LONG* atomic_counter = (LONG*)(&prm->atomic_counter);
    int src_bpl = prm->src_bpl;
    int dest_bpl = prm->dest_bpl;
    int maxblock = (height + 7) / 8;
    while (TRUE)
    {
        int block = InterlockedIncrement(atomic_counter) - 1;
        if (block >= maxblock) break;
        int y0, y1, y2;
        y1 = block * 8;
        y0 = y1 - 2;
        y2 = y1 + 9;
        int yloop1, yloop2, yloop3;
        yloop2 = y2 - y0;
        if (y0 < 0)
        {
            yloop1 = 2;
            yloop2 -= 2;
        }
        else
        {
            yloop1 = 0;
        }
        if (y2 > height)
        {
            yloop3 = y2 - height;
            yloop2 -= yloop3;
        }
        else
        {
            yloop3 = 0;
        }

        int xloopcount = (width + 15) / 16;
        BYTE* src2 = src + (y0 + yloop1) * src_bpl;
        BYTE* dest2 = dest + y1 * dest_bpl / 2;
        BYTE* ywork2 = ywork + yloop1 * 64;
        BYTE* xwork2;
        __asm
        {
            mov             ecx, xloopcount
            mov             edi, xwork
            mov             eax, src_bpl
            mov             esi, src2
        align 16
        xloop_1:
            mov             xloopcount, ecx
            mov             xwork2, edi
            mov             edi, ywork2
            mov             ecx, yloop2
            
        align 16
        loop_1:
            pinsrw          xmm0, [esi], 1
            pinsrw          xmm0, [esi+6], 3
            pinsrw          xmm0, [esi+12], 5
            pinsrw          xmm0, [esi+18], 7
            pinsrw          xmm1, [esi+24], 1
            pinsrw          xmm1, [esi+30], 3
            pinsrw          xmm1, [esi+36], 5
            pinsrw          xmm1, [esi+42], 7
            pinsrw          xmm2, [esi+48], 1
            pinsrw          xmm2, [esi+54], 3
            pinsrw          xmm2, [esi+60], 5
            pinsrw          xmm2, [esi+66], 7
            pinsrw          xmm3, [esi+72], 1
            pinsrw          xmm3, [esi+78], 3
            pinsrw          xmm3, [esi+84], 5
            pinsrw          xmm3, [esi+90], 7
            psrad           xmm0, 16
            psrad           xmm1, 16
            psrad           xmm2, 16
            psrad           xmm3, 16
            cvtdq2ps        xmm0, xmm0
            cvtdq2ps        xmm1, xmm1
            cvtdq2ps        xmm2, xmm2
            cvtdq2ps        xmm3, xmm3
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
            movaps          [edi+48], xmm3
            add             esi, eax
            add             edi, 64
            sub             ecx, 1
            jnz             loop_1
            
            mov             ecx, yloop3
            test            ecx, ecx
            jz              loop_2_end
            sub             esi, eax
            sub             esi, eax
        align 16
        loop_2:
            pinsrw          xmm0, [esi], 1
            pinsrw          xmm0, [esi+6], 3
            pinsrw          xmm0, [esi+12], 5
            pinsrw          xmm0, [esi+18], 7
            pinsrw          xmm1, [esi+24], 1
            pinsrw          xmm1, [esi+30], 3
            pinsrw          xmm1, [esi+36], 5
            pinsrw          xmm1, [esi+42], 7
            pinsrw          xmm2, [esi+48], 1
            pinsrw          xmm2, [esi+54], 3
            pinsrw          xmm2, [esi+60], 5
            pinsrw          xmm2, [esi+66], 7
            pinsrw          xmm3, [esi+72], 1
            pinsrw          xmm3, [esi+78], 3
            pinsrw          xmm3, [esi+84], 5
            pinsrw          xmm3, [esi+90], 7
            psrad           xmm0, 16
            psrad           xmm1, 16
            psrad           xmm2, 16
            psrad           xmm3, 16
            cvtdq2ps        xmm0, xmm0
            cvtdq2ps        xmm1, xmm1
            cvtdq2ps        xmm2, xmm2
            cvtdq2ps        xmm3, xmm3
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
            movaps          [edi+48], xmm3
            sub             esi, eax
            add             edi, 64
            sub             ecx, 1
            jnz             loop_2
        loop_2_end:
            
            mov             ecx, yloop1
            test            ecx, ecx
            jz              padding_end
            mov             edi, ywork2
            movaps          xmm0, [edi+64]
            movaps          xmm1, [edi+80]
            movaps          xmm2, [edi+96]
            movaps          xmm3, [edi+112]
            movaps          [edi-64 ], xmm0
            movaps          [edi-48 ], xmm1
            movaps          [edi-32 ], xmm2
            movaps          [edi-16 ], xmm3
            movaps          xmm0, [edi+128]
            movaps          xmm1, [edi+144]
            movaps          xmm2, [edi+160]
            movaps          xmm3, [edi+176]
            movaps          [edi-128 ], xmm0
            movaps          [edi-112 ], xmm1
            movaps          [edi-96  ], xmm2
            movaps          [edi-80  ], xmm3
        padding_end:
            
            movaps          xmm7, predict
            movaps          xmm6, update
            mov             esi, ywork
            mov             edi, xwork2
            mov             ecx, 4
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            addps           xmm0, [esi+128]
            addps           xmm1, [esi+144]
            mulps           xmm0, xmm7
            mulps           xmm1, xmm7
            addps           xmm0, [esi+64]
            addps           xmm1, [esi+80]
            add             esi, 128
        align 16
        loop_3:
            movaps          xmm2, [esi]
            movaps          xmm3, [esi+16]
            movaps          xmm4, [esi+128]
            movaps          xmm5, [esi+144]
            addps           xmm4, xmm2
            addps           xmm5, xmm3
            mulps           xmm4, xmm7
            mulps           xmm5, xmm7
            addps           xmm4, [esi+64]
            addps           xmm5, [esi+80]
            addps           xmm0, xmm4
            addps           xmm1, xmm5
            mulps           xmm0, xmm6
            mulps           xmm1, xmm6
            addps           xmm2, xmm0
            addps           xmm3, xmm1
            movaps          xmm0, xmm4
            movaps          xmm1, xmm5
            movaps          [esi], xmm2
            movaps          [esi+16], xmm3
            add             esi, 128
            sub             ecx, 1
            jnz             loop_3
            
            sub             esi, 128*5-32
            mov             ecx, 4
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            addps           xmm0, [esi+128]
            addps           xmm1, [esi+144]
            mulps           xmm0, xmm7
            mulps           xmm1, xmm7
            addps           xmm0, [esi+64]
            addps           xmm1, [esi+80]
            add             esi, 128
        align 16
        loop_4:
            movaps          xmm2, [esi]
            movaps          xmm3, [esi+16]
            movaps          xmm4, [esi+128]
            movaps          xmm5, [esi+144]
            addps           xmm4, xmm2
            addps           xmm5, xmm3
            mulps           xmm4, xmm7
            mulps           xmm5, xmm7
            addps           xmm4, [esi+64]
            addps           xmm5, [esi+80]
            addps           xmm0, xmm4
            addps           xmm1, xmm5
            mulps           xmm0, xmm6
            mulps           xmm1, xmm6
            addps           xmm2, xmm0
            addps           xmm3, xmm1
            movaps          xmm0, xmm4
            movaps          xmm1, xmm5
            movaps          [esi], xmm2
            movaps          [esi+16], xmm3
            add             esi, 128
            sub             ecx, 1
            jnz             loop_4
            
            sub             esi, 128*4+32
            mov             ecx, 4
        align 16
        loop_5:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+128]
            movaps          xmm2, [esi+256]
            movaps          xmm3, [esi+384]
            movaps          xmm4, xmm0
            movaps          xmm5, xmm1
            unpcklps        xmm4, xmm2
            unpckhps        xmm0, xmm2
            unpcklps        xmm5, xmm3
            unpckhps        xmm1, xmm3
            movaps          xmm2, xmm4
            movaps          xmm3, xmm0
            unpcklps        xmm2, xmm5
            unpckhps        xmm4, xmm5
            unpcklps        xmm3, xmm1
            unpckhps        xmm0, xmm1
            movaps          [edi], xmm2
            movaps          [edi+16], xmm4
            movaps          [edi+32], xmm3
            movaps          [edi+48], xmm0
            add             esi, 16
            add             edi, 64
            sub             ecx, 1
            jnz             loop_5
            
            mov             esi, src2
            mov             ecx, xloopcount
            add             esi, 96
            mov             src2, esi
            sub             ecx, 1
            jnz             xloop_1
        }
        xwork2 = xwork + 16 * width;
        __asm
        {
            mov             edx, xwork2
            movaps          xmm0, [edx-32]
            movaps          [edx], xmm0
        }
        xwork2 = xwork;
        
        for(int x=0; x<width; x+=160)
        {
            int xloop1;
            if (width - x > 160) xloop1 = 80;
            else xloop1 = (width - x) / 2;
            
            if (x!=0)
            {
                __asm
                {
                    movaps          xmm7, predict
                    movaps          xmm6, update
                    mov             esi, xwork2
                    mov             ecx, xloop1
                    
                    movaps          xmm4, [esi-16]
                    movaps          xmm5, [esi]
                    sub             ecx, 1
                    jz              loop_6_last
                align 16
                loop_6:
                    movaps          xmm0, [esi+32]
                    movaps          xmm1, [esi+64]
                    movaps          xmm2, xmm0
                    movaps          xmm3, xmm1
                    addps           xmm0, xmm5
                    addps           xmm1, xmm2
                    mulps           xmm0, xmm7
                    mulps           xmm1, xmm7
                    addps           xmm0, [esi+16]
                    addps           xmm1, [esi+48]
                    addps           xmm4, xmm0
                    addps           xmm0, xmm1
                    mulps           xmm4, xmm6
                    mulps           xmm0, xmm6
                    addps           xmm4, xmm5
                    addps           xmm0, xmm2
                    movaps          [esi], xmm4
                    movaps          [esi+32], xmm0
                    movaps          xmm4, xmm1
                    movaps          xmm5, xmm3
                    add             esi, 64
                    sub             ecx, 2
                    jnle            loop_6
                loop_6_last:
                    add             ecx, 1
                    jz              loop_6_end
                    
                    movaps          xmm0, [esi+32]
                    movaps          xmm1, [esi+16]
                    addps           xmm0, xmm5
                    mulps           xmm0, xmm7
                    addps           xmm1, xmm0
                    addps           xmm4, xmm1
                    mulps           xmm4, xmm6
                    addps           xmm5, xmm4
                    movaps          [esi], xmm5
                    movaps          xmm4, xmm1
                    add             esi, 32
                loop_6_end:
                    movaps          [esi-16], xmm4
                }
            }
            else
            {
                __asm
                {
                    movaps          xmm7, predict
                    movaps          xmm6, update
                    mov             esi, xwork2
                    mov             ecx, xloop1
                    
                    movaps          xmm0, [esi]
                    movaps          xmm4, [esi+16]
                    movaps          xmm2, [esi+32]
                    movaps          xmm5, xmm0
                    addps           xmm0, xmm2
                    mulps           xmm0, xmm7
                    addps           xmm4, xmm0
                    sub             ecx, 1
                    jz              loop_7_last
                align 16
                loop_7:
                    movaps          xmm0, [esi+32]
                    movaps          xmm1, [esi+64]
                    movaps          xmm2, xmm0
                    movaps          xmm3, xmm1
                    addps           xmm0, xmm5
                    addps           xmm1, xmm2
                    mulps           xmm0, xmm7
                    mulps           xmm1, xmm7
                    addps           xmm0, [esi+16]
                    addps           xmm1, [esi+48]
                    addps           xmm4, xmm0
                    addps           xmm0, xmm1
                    mulps           xmm4, xmm6
                    mulps           xmm0, xmm6
                    addps           xmm4, xmm5
                    addps           xmm0, xmm2
                    movaps          [esi], xmm4
                    movaps          [esi+32], xmm0
                    movaps          xmm4, xmm1
                    movaps          xmm5, xmm3
                    add             esi, 64
                    sub             ecx, 2
                    jnle            loop_7
                loop_7_last:
                    add             ecx, 1
                    jz              loop_7_end
                    
                    movaps          xmm0, [esi+32]
                    movaps          xmm1, [esi+16]
                    addps           xmm0, xmm5
                    mulps           xmm0, xmm7
                    addps           xmm1, xmm0
                    addps           xmm4, xmm1
                    mulps           xmm4, xmm6
                    addps           xmm5, xmm4
                    movaps          [esi], xmm5
                    movaps          xmm4, xmm1
                    add             esi, 32
                loop_7_end:
                    movaps          [esi-16], xmm4
                }
            }
            
            BYTE* xwork3 = xwork2;
            BYTE* dest3 = dest2;
            __asm
            {
                mov             ebx, 2
                mov             esi, xwork3
                mov             edi, dest3
                mov             eax, dest_bpl
            loop_8:
                mov             ecx, xloop1
            align 16
            loop_9:
                movlps          xmm0, [esi]
                movlps          xmm1, [esi+32]
                movlps          xmm2, [esi+64]
                movlps          xmm3, [esi+96]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi], xmm0
                movntps         [edi+eax], xmm2
                movlps          xmm0, [esi+128]
                movlps          xmm1, [esi+160]
                movlps          xmm2, [esi+192]
                movlps          xmm3, [esi+224]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                movntps         [edi+16], xmm0
                movntps         [edi+eax+16], xmm2
                add             esi, 256
                add             edi, 32
                sub             ecx, 8
                jnle            loop_9
                
                mov             edi, dest3
                mov             esi, xwork3
                lea             edi, [edi+eax*2]
                add             esi, 8
                mov             dest3, edi
                mov             xwork3, esi
                sub             ebx, 1
                jnz             loop_8
            }
            xwork2 += 160 * 16;
            dest2 += 80 * 4;
        }
    }
}

void iwt53_luma(int thread_id,int thread_num,void *param1, void* param2)
{
    WAVELET_PARAM* prm = (WAVELET_PARAM*)param1;
    int width = prm->destwidth;
    int height = (prm->destheight+3)&~3;
    int halfw = (prm->destwidth + 1) / 2;
    int halfh = height / 2;
    BYTE* src = prm->src;
    BYTE* dest = prm->dest;
    BYTE* ywork = work + worksize * thread_id;
    BYTE* xwork = ywork + 64 * (4 + 2 + 2);
    LONG* atomic_counter = (LONG*)(&prm->atomic_counter);
    int src_bpl = prm->src_bpl;
    int dest_bpl = prm->dest_bpl;
    int maxblock = (height+3) / 4;
    int v_hi = (prm->srcheight / 2) * src_bpl;
    int h_hi = (prm->srcwidth / 2) * 4;
    int xworkhalf = ((((halfw + 15) &~15) + 1) * 16 +127) &~127;
    int xloop1 = (halfw + 15) / 16;
    while (TRUE)
    {
        int block = InterlockedIncrement(atomic_counter) - 1;
        if (block >= maxblock) break;
        int y0, y1, y2;
        y1 = block * 2;
        y0 = y1 - 1;
        y2 = y1 + 3;
        int yloop1, yloop2, yloop3;
        yloop2 = y2 - y0;
        if (y0 < 0)
        {
            yloop1 = 1;
            yloop2 -= 1;
        }
        else
        {
            yloop1 = 0;
        }
        if (y2 > halfh)
        {
            yloop3 = y2 - halfh;
            yloop2 -= yloop3;
        }
        else
        {
            yloop3 = 0;
        }

        BYTE* src2 = src + (y0 + yloop1) * src_bpl;
        BYTE* dest2 = dest + y1 * dest_bpl * 2;
        BYTE* ywork2 = ywork + yloop1 * 128;
        BYTE* xwork2 = xwork;
        BYTE* src3 = src2;
        int xloop2;
        __asm
        {
            mov             ecx, xloop1
            mov             esi, src3
            mov             eax, src_bpl
            mov             edx, v_hi
            mov             ebx, 2
        align 16
        xloop_1:
            mov             xloop2, ecx
            mov             edi, ywork2
            mov             ecx, yloop2
        align 16
        loop_1:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            movaps          xmm2, [esi+32]
            movaps          xmm3, [esi+48]
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
            movaps          [edi+48], xmm3
            movaps          xmm0, [esi+edx]
            movaps          xmm1, [esi+edx+16]
            movaps          xmm2, [esi+edx+32]
            movaps          xmm3, [esi+edx+48]
            movaps          [edi+64], xmm0
            movaps          [edi+80], xmm1
            movaps          [edi+96], xmm2
            movaps          [edi+112], xmm3
            add             esi, eax
            add             edi, 128
            sub             ecx, 1
            jnz             loop_1
            
            mov             ecx, yloop3
            test            ecx, ecx
            jz              loop_2_end
            lea             esi, [edi-192]
        align 16
        loop_2:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            movaps          xmm2, [esi+32]
            movaps          xmm3, [esi+48]
            movaps          [edi+64], xmm0
            movaps          [edi+80], xmm1
            movaps          [edi+96], xmm2
            movaps          [edi+112], xmm3
            movaps          xmm0, [esi+64]
            movaps          xmm1, [esi+80]
            movaps          xmm2, [esi+96]
            movaps          xmm3, [esi+112]
            movaps          [edi], xmm0
            movaps          [edi+16], xmm1
            movaps          [edi+32], xmm2
            movaps          [edi+48], xmm3
            sub             esi, 128
            add             edi, 128
            sub             ecx, 1
            jnz             loop_2
            loop_2_end:
            
            mov             ecx, yloop1
            test            ecx, ecx
            jz              padding_end
            mov             edi, ywork2
            mov             esi, edi
            movaps          xmm0, [edi+64]
            movaps          xmm1, [edi+80]
            movaps          xmm2, [edi+96]
            movaps          xmm3, [esi+112]
            movaps          [edi-64], xmm0
            movaps          [edi-48], xmm1
            movaps          [edi-32], xmm2
            movaps          [edi-16], xmm3
            movaps          xmm0, [esi+128]
            movaps          xmm1, [esi+144]
            movaps          xmm2, [esi+160]
            movaps          xmm3, [esi+176]
            movaps          [edi-128], xmm0
            movaps          [edi-112], xmm1
            movaps          [edi-96], xmm2
            movaps          [edi-80], xmm3
        padding_end:
            
            movaps          xmm7, i_update
            movaps          xmm6, i_predict
            mov             esi, ywork
            mov             edi, xwork2
            mov             ecx, 2
            add             esi, 64
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            movaps          xmm2, [esi+32]
            movaps          xmm3, [esi+48]
            addps           xmm0, [esi+128]
            addps           xmm1, [esi+144]
            addps           xmm2, [esi+160]
            addps           xmm3, [esi+176]
            mulps           xmm0, xmm7
            mulps           xmm1, xmm7
            mulps           xmm2, xmm7
            mulps           xmm3, xmm7
            addps           xmm0, [esi+64]
            addps           xmm1, [esi+80]
            addps           xmm2, [esi+96]
            addps           xmm3, [esi+112]
            movaps          [esi+64], xmm0
            movaps          [esi+80], xmm1
            movaps          [esi+96], xmm2
            movaps          [esi+112], xmm3
            add             esi, 128
        align 16
        loop_3:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+16]
            movaps          xmm2, [esi+32]
            movaps          xmm3, [esi+48]
            addps           xmm0, [esi+128]
            addps           xmm1, [esi+144]
            addps           xmm2, [esi+160]
            addps           xmm3, [esi+176]
            mulps           xmm0, xmm7
            mulps           xmm1, xmm7
            mulps           xmm2, xmm7
            mulps           xmm3, xmm7
            addps           xmm0, [esi+64]
            addps           xmm1, [esi+80]
            addps           xmm2, [esi+96]
            addps           xmm3, [esi+112]
            movaps          [esi+64], xmm0
            movaps          [esi+80], xmm1
            movaps          [esi+96], xmm2
            movaps          [esi+112], xmm3
            addps           xmm0, [esi-64]
            addps           xmm1, [esi-48]
            addps           xmm2, [esi-32]
            addps           xmm3, [esi-16]
            mulps           xmm0, xmm6
            mulps           xmm1, xmm6
            mulps           xmm2, xmm6
            mulps           xmm3, xmm6
            addps           xmm0, [esi]
            addps           xmm1, [esi+16]
            addps           xmm2, [esi+32]
            addps           xmm3, [esi+48]
            movaps          [esi], xmm0
            movaps          [esi+16], xmm1
            movaps          [esi+32], xmm2
            movaps          [esi+48], xmm3
            add             esi, 128
            sub             ecx, 1
            jnz             loop_3
            
            sub             esi, 64*5
            mov             ecx, 4
        align 16
        loop_4:
            movaps          xmm0, [esi]
            movaps          xmm1, [esi+64]
            movaps          xmm2, [esi+128]
            movaps          xmm3, [esi+192]
            movaps          xmm4, xmm0
            movaps          xmm5, xmm1
            unpcklps        xmm0, xmm2
            unpckhps        xmm4, xmm2
            unpcklps        xmm1, xmm3
            unpckhps        xmm5, xmm3
            movaps          xmm2, xmm0
            movaps          xmm3, xmm4
            unpcklps        xmm0, xmm1
            unpckhps        xmm2, xmm1
            unpcklps        xmm4, xmm5
            unpckhps        xmm3, xmm5
            movaps          [edi], xmm0
            movaps          [edi+16], xmm2
            movaps          [edi+32], xmm4
            movaps          [edi+48], xmm3
            add             esi, 16
            add             edi, 64
            sub             ecx, 1
            jnz             loop_4
            
            mov             esi, src3
            mov             ecx, xloop2
            add             esi, 64
            mov             xwork2, edi
            mov             src3, esi
            sub             ecx, 1
            jnz             xloop_1
            
            sub             ebx, 1
            jz              xloop_1_end
            
            mov             esi, src2
            mov             edi, xwork
            add             esi, h_hi
            add             edi, xworkhalf
            mov             src3, esi
            mov             xwork2, edi
            mov             ecx, xloop1
            jmp             xloop_1
        xloop_1_end:
        }

        xwork2 = xwork + 16 * halfw;
        BYTE* xwork3 = xwork + 16 * halfw + xworkhalf;
        __asm
        {
            mov             esi, xwork2
            mov             edi, xwork3
            movaps          xmm0, [esi-16]
            movaps          [esi], xmm0
            movaps          xmm1, [edi-32]
            movaps          [edi], xmm1
        }
        
        xwork2 = xwork;
        for(int x=0; x<halfw; x+=80)
        {
            int xloop3;
            if (halfw - x > 80) xloop3 = 80;
            else xloop3 = halfw - x;
            if(x!=0)
            {
                __asm
                {
                    movaps          xmm7, i_update
                    movaps          xmm6, i_predict
                    mov             esi, xwork2
                    mov             edx, xworkhalf
                    mov             ecx, xloop3
                    movaps          xmm4, [esi]
                    movaps          xmm5, [esi+edx]
                    sub             ecx, 1
                    jz              loop_5_last
                align 16
                loop_5:
                    movaps          xmm0, [esi+edx+16]
                    movaps          xmm1, [esi+edx+32]
                    movaps          xmm2, xmm0
                    movaps          xmm3, xmm1
                    addps           xmm0, xmm5
                    addps           xmm1, xmm2
                    mulps           xmm0, xmm7
                    mulps           xmm1, xmm7
                    addps           xmm0, [esi+16]
                    addps           xmm1, [esi+32]
                    movaps          [esi+16], xmm0
                    movaps          [esi+32], xmm1
                    addps           xmm4, xmm0
                    addps           xmm0, xmm1
                    mulps           xmm4, xmm6
                    mulps           xmm0, xmm6
                    addps           xmm5, xmm4
                    addps           xmm2, xmm0
                    movaps          [esi+edx], xmm5
                    movaps          [esi+edx+16], xmm2
                    movaps          xmm4, xmm1
                    movaps          xmm5, xmm3
                    add             esi, 32
                    sub             ecx, 2
                    jnle            loop_5
                loop_5_last:
                    add             ecx, 1
                    jz              loop_5_end
                    
                    movaps          xmm0, [esi+edx+16]
                    movaps          xmm1, [esi+16]
                    addps           xmm0, xmm5
                    mulps           xmm0, xmm7
                    addps           xmm1, xmm0
                    movaps          [esi+16], xmm1
                    addps           xmm4, xmm1
                    mulps           xmm4, xmm6
                    addps           xmm5, xmm4
                    movaps          [esi+edx], xmm5
                loop_5_end:
                }
            }
            else
            {
                __asm
                {
                    movaps          xmm7, i_update
                    movaps          xmm6, i_predict
                    mov             esi, xwork2
                    mov             edx, xworkhalf
                    mov             ecx, xloop3
                    
                    movaps          xmm0, [esi+edx]
                    movaps          xmm4, [esi]
                    movaps          xmm5, xmm0
                    addps           xmm0, xmm0
                    mulps           xmm0, xmm7
                    addps           xmm4, xmm0
                    movaps          [esi], xmm4
                    sub             ecx, 1
                    jz              loop_6_last
                align 16
                loop_6:
                    movaps          xmm0, [esi+edx+16]
                    movaps          xmm1, [esi+edx+32]
                    movaps          xmm2, xmm0
                    movaps          xmm3, xmm1
                    addps           xmm0, xmm5
                    addps           xmm1, xmm2
                    mulps           xmm0, xmm7
                    mulps           xmm1, xmm7
                    addps           xmm0, [esi+16]
                    addps           xmm1, [esi+32]
                    movaps          [esi+16], xmm0
                    movaps          [esi+32], xmm1
                    addps           xmm4, xmm0
                    addps           xmm0, xmm1
                    mulps           xmm4, xmm6
                    mulps           xmm0, xmm6
                    addps           xmm5, xmm4
                    addps           xmm2, xmm0
                    movaps          [esi+edx], xmm5
                    movaps          [esi+edx+16], xmm2
                    movaps          xmm4, xmm1
                    movaps          xmm5, xmm3
                    add             esi, 32
                    sub             ecx, 2
                    jnle            loop_6
                loop_6_last:
                    add             ecx, 1
                    jz              loop_6_end
                    
                    movaps          xmm0, [esi+edx+16]
                    movaps          xmm1, [esi+16]
                    addps           xmm0, xmm5
                    mulps           xmm0, xmm7
                    addps           xmm1, xmm0
                    movaps          [esi+16], xmm1
                    addps           xmm4, xmm1
                    mulps           xmm4, xmm6
                    addps           xmm5, xmm4
                    movaps          [esi+edx], xmm5
                loop_6_end:
                }
            }
            
            BYTE* xwork3 = xwork2;
            BYTE* dest3 = dest2;
            __asm
            {
                mov             ebx, 2
                mov             esi, xwork3
                mov             edi, dest3
                mov             edx, xworkhalf
                mov             eax, dest_bpl
            align 16
            loop_7:
                push            ebx
                mov             ecx, xloop3
                
            align 16
            loop_8:
                movlps          xmm0, [esi]
                movlps          xmm1, [esi+edx]
                movlps          xmm2, [esi+16]
                movlps          xmm3, [esi+edx+16]
                unpcklps        xmm0, xmm2
                unpcklps        xmm1, xmm3
                movaps          xmm2, xmm0
                unpcklps        xmm0, xmm1
                unpckhps        xmm2, xmm1
                cvtps2dq        xmm0, xmm0
                cvtps2dq        xmm2, xmm2
                pextrw          ebx, xmm0, 0
                mov             [edi], bx
                pextrw          ebx, xmm0, 2
                mov             [edi+6], bx
                pextrw          ebx, xmm0, 4
                mov             [edi+12], bx
                pextrw          ebx, xmm0, 6
                mov             [edi+18], bx
                pextrw          ebx, xmm2, 0
                mov             [edi+eax], bx
                pextrw          ebx, xmm2, 2
                mov             [edi+eax+6], bx
                pextrw          ebx, xmm2, 4
                mov             [edi+eax+12], bx
                pextrw          ebx, xmm2, 6
                mov             [edi+eax+18], bx
                add             esi, 32
                add             edi, 24
                sub             ecx, 2
                jnle            loop_8
                
                pop             ebx
                mov             edi, dest3
                mov             esi, xwork3
                lea             edi, [edi+eax*2]
                add             esi, 8
                mov             dest3, edi
                mov             xwork3, esi
                sub             ebx, 1
                jnz             loop_7
            }
            xwork2 += 80 * 16;
            dest2 += 160 * 6;
        }
    }
}

void blend_lo(int thread_id,int thread_num,void *param1, void* param2)
{
    int width = before.destwidth;
    int height = before.destheight;
    int y_start = thread_id * height / thread_num;
    int y_end = (thread_id+1) * height / thread_num;
    int xloopcount = width / 4;
    int yloopcount = y_end - y_start;
    BYTE* src = before.dest + y_start * before.dest_bpl;
    BYTE* dest = after.dest + y_start * after.dest_bpl;
    int deststep = after.dest_bpl - xloopcount * 48;
    int srcstep = before.dest_bpl - xloopcount * 48;
    float w1 = str / 100;
    float w2 = 1.0f - w1;
    __asm
    {
        movss           xmm6, w2
        movss           xmm7, w1
        shufps          xmm6, xmm6, 0
        shufps          xmm7, xmm7, 0
        mov             edx, dest
        mov             eax, src
        mov             ebx, yloopcount
    yloop:
        mov             ecx, xloopcount
    align 16
    xloop:
        movaps          xmm0, [edx]
        movaps          xmm1, [edx+16]
        movaps          xmm2, [edx+32]
        movaps          xmm3, [eax]
        movaps          xmm4, [eax+16]
        movaps          xmm5, [eax+32]
        mulps           xmm0, xmm6
        mulps           xmm1, xmm6
        mulps           xmm2, xmm6
        mulps           xmm3, xmm7
        mulps           xmm4, xmm7
        mulps           xmm5, xmm7
        addps           xmm0, xmm3
        addps           xmm1, xmm4
        addps           xmm2, xmm5
        movaps          [edx], xmm0
        movaps          [edx+16], xmm1
        movaps          [edx+32], xmm2
        add             edx, 48
        add             eax, 48
        sub             ecx, 1
        jnz             xloop
        add             edx, deststep
        add             eax, srcstep
        sub             ebx, 1
        jnz             yloop
    }
}

void blend_lo_luma(int thread_id,int thread_num,void *param1, void* param2)
{
    int width = before.destwidth;
    int height = before.destheight;
    int y_start = thread_id * height / thread_num;
    int y_end = (thread_id+1) * height / thread_num;
    int xloopcount = width / 4;
    int yloopcount = y_end - y_start;
    BYTE* src = before.dest + y_start * before.dest_bpl;
    BYTE* dest = after.dest + y_start * after.dest_bpl;
    int deststep = after.dest_bpl - xloopcount * 16;
    int srcstep = before.dest_bpl - xloopcount * 16;
    float w1 = str / 100;
    float w2 = 1.0f - w1;
    __asm
    {
        movss           xmm6, w2
        movss           xmm7, w1
        shufps          xmm6, xmm6, 0
        shufps          xmm7, xmm7, 0
        mov             edx, dest
        mov             eax, src
        mov             ebx, yloopcount
    yloop:
        mov             ecx, xloopcount
        sub             ecx, 1
        jz              xloop_last
    align 16
    xloop:
        movaps          xmm0, [edx]
        movaps          xmm1, [edx+16]
        movaps          xmm3, [eax]
        movaps          xmm4, [eax+16]
        mulps           xmm0, xmm6
        mulps           xmm1, xmm6
        mulps           xmm3, xmm7
        mulps           xmm4, xmm7
        addps           xmm0, xmm3
        addps           xmm1, xmm4
        movaps          [edx], xmm0
        movaps          [edx+16], xmm1
        add             edx, 32
        add             eax, 32
        sub             ecx, 2
        jnle            xloop
    xloop_last:
        add             ecx, 1
        jz              xloop_end
        movaps          xmm0, [edx]
        movaps          xmm3, [eax]
        mulps           xmm0, xmm6
        mulps           xmm3, xmm7
        addps           xmm0, xmm3
        movaps          [edx], xmm0
        add             edx, 16
        add             eax, 16
    xloop_end:
        
        add             edx, deststep
        add             eax, srcstep
        sub             ebx, 1
        jnz             yloop
    }
}

static void check_threadcount( int thread_id,int thread_num,void *param1,void *param2 )
{
    if (thread_id == 0) *(int*)param1 = thread_num;
}

void releasemem()
{
    if(work != NULL) _mm_free(work);
    work = NULL;
    if(before.dest != NULL) _mm_free(before.dest);
    if(after.dest != NULL) _mm_free(after.dest);
    before.dest = NULL;
    after.dest = NULL;
}

void recovery(FILTER *fp, FILTER_PROC_INFO *fpip)
{
    
    if((work != NULL) && (fpip->w == before.srcwidth) && (fpip->h == before.srcheight) && (done == FALSE))
    {
        after.src = (BYTE*)fpip->ycp_edit;
        after.atomic_counter = 0;
        if (lumaonly == FALSE)
        {
            fp->exfunc->exec_multi_thread_func(fwt53, (void*)&after, NULL);
            fp->exfunc->exec_multi_thread_func(blend_lo, NULL, NULL);
        }
        else
        {
            fp->exfunc->exec_multi_thread_func(fwt53_luma, (void*)&after, NULL);
            fp->exfunc->exec_multi_thread_func(blend_lo_luma, NULL, NULL);
        }
        WAVELET_PARAM iwt;
        iwt.src = after.dest;
        iwt.dest = (BYTE*)fpip->ycp_edit;
        iwt.srcwidth = after.destwidth;
        iwt.srcheight = after.destheight;
        iwt.destwidth = after.srcwidth;
        iwt.destheight = after.srcheight;
        iwt.src_bpl = after.dest_bpl;
        iwt.dest_bpl = fpip->max_w * 6;
        iwt.atomic_counter = 0;
        if (lumaonly == FALSE)  fp->exfunc->exec_multi_thread_func(iwt53, (void*)&iwt, NULL);
        fp->exfunc->exec_multi_thread_func(iwt53_luma, (void*)&iwt, NULL);
        done = TRUE;
    }
}

//---------------------------------------------------------------------
//        tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
    int threadcount = 0;
    fp->exfunc->exec_multi_thread_func(check_threadcount, &threadcount, NULL);
    if (threadcount != maxthread)
    {
        if(work != NULL) _mm_free(work);
        work = NULL;
        maxthread = threadcount;
    }

    if (before.srcwidth != fpip->w || before.srcheight != fpip->h)
    {
        releasemem();
        before.srcwidth = fpip->w;
        before.srcheight = fpip->h;
        before.destwidth = ((fpip->w + 15) &~15) / 2;
        before.destheight = ((fpip->h + 15) &~15) / 2;
        before.src_bpl = fpip->max_w * 6;
        if (lumaonly == FALSE) before.dest_bpl = (before.destwidth * 12 + 63) &~63;
        else before.dest_bpl = (before.destwidth * 4 + 63) &~63;
        if ((before.dest_bpl & 4095) == 0) before.dest_bpl += 64;
        
        after.srcwidth = fpip->w;
        after.srcheight = fpip->h;
        after.destwidth = (fpip->w + 15) & ~15;
        after.destheight = (fpip->h + 15) & ~15;
        after.src_bpl = fpip->max_w * 6;
        if (lumaonly == FALSE) after.dest_bpl = after.destwidth * 12;
        else after.dest_bpl = after.destwidth * 4;
        if ((after.dest_bpl & 4095) == 0) after.dest_bpl += 64;
        
        before.dest = (BYTE*)_mm_malloc(before.dest_bpl * before.destheight, 64);
        after.dest = (BYTE*)_mm_malloc(after.dest_bpl * after.destheight, 64);
    }
    if (work == NULL)
    {
        int xworksize = (((((before.destwidth +15) &~15) + 1) * 48 + 63) &~63) * 2;
        worksize = 64 * 12 + xworksize;
        work = (BYTE*)_mm_malloc(worksize * maxthread, 64);
    }
    before.src = (BYTE*)fpip->ycp_edit;
    before.atomic_counter = 0;
    if (lumaonly == FALSE) fp->exfunc->exec_multi_thread_func(fwt53_LL, (void*)&before, NULL);
    else fp->exfunc->exec_multi_thread_func(fwt53_LL_luma, (void*)&before, NULL);
    done = FALSE;
    return TRUE;
}

BOOL func_exit( FILTER *fp )
{
    releasemem();
    return TRUE;
}

BOOL func_update( FILTER *fp,int status )
{
    str = (float)fp->track[0];
    BOOL b = fp->check[0] != 0;
    if(lumaonly != b)
    {
        releasemem();
        before.srcwidth = 0;
        before.srcheight = 0;
        lumaonly = b;
    }
    return TRUE;
}

BOOL func_WndProc( HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam,void *editp,FILTER *fp )
{
    if (message == WM_FILTER_CHANGE_ACTIVE)
    {
        if (fp->exfunc->is_filter_active(fp) == FALSE)
        {
            releasemem();
            before.srcwidth = 0;
            before.srcheight = 0;
        }
    }
    return FALSE;
}